
#ifndef _OGR_FGD_H_INCLUDED
#define _OGR_FGD_H_INCLUDED

#include "ogrsf_frmts.h"
#include "fgdreader.h"

/************************************************************************/
/*                             OGRFGDLayer                              */
/************************************************************************/

class OGRFGDLayer	:	public OGRLayer
{

public:

	OGRFGDLayer( const char *pszFilename );
	~OGRFGDLayer();

	void ResetReading();
	OGRFeature *GetNextFeature();
	OGRFeatureDefn *GetLayerDefn();
	int TestCapability( const char * ){ return FALSE; }
	OGRSpatialReference* GetSpatialRef();

	inline bool isValid() const { return m_bValid; }

private:

	OGRFeatureDefn *poFeatureDefn;
	int nNextFID;

#if defined(HAVE_EXPAT) && defined(HAVE_ICONV)
	FGDReader *m_pReader;
#endif

	bool m_bValid;
};


/************************************************************************/
/*                             OGRFGDDataSource                         */
/************************************************************************/

class OGRFGDDataSource	:	public OGRDataSource
{
public:

	OGRFGDDataSource();
	~OGRFGDDataSource();

	int Open( const char *pszFinename, int bUpdate );
	const char *GetName(){ return pszName; }
	int GetLayerCount(){ return nLayers; }
	OGRLayer *GetLayer( int );
	int TestCapability( const char * ){ return FALSE; }

private:

	char				*pszName;
	OGRFGDLayer			**papoLayers;
	int					nLayers;
};

/************************************************************************/
/*                             OGRFGDDriver                             */
/************************************************************************/

class OGRFGDDriver : public OGRSFDriver
{
public:
	~OGRFGDDriver();
	const char *GetName();
	OGRDataSource *Open( const char *, int );
	int TestCapability( const char * );
};

#endif /* _OGR_FGD_H_INCLUDED */
