
#include "ogr_fgd.h"

OGRFGDDataSource::OGRFGDDataSource()
{
	papoLayers = NULL;
	nLayers = 0;
	pszName = NULL;
}

OGRFGDDataSource::~OGRFGDDataSource()
{
	for ( int i = 0; i < nLayers; i++ )
		delete papoLayers[i];

	CPLFree( papoLayers );
	CPLFree( pszName );
}


int OGRFGDDataSource::Open( const char *pszFilename, int bUpdate )
{
	const char *pszExtension = CPLGetExtension( pszFilename);

	if ( !EQUAL( pszExtension, "xml" ) )
	{
		return FALSE;
	}

	if ( bUpdate )
	{
		CPLError( CE_Failure, CPLE_OpenFailed,
			"Update access not supported by the FGD driver." );
		return FALSE;
	}

	nLayers = 1;

	papoLayers = (OGRFGDLayer **)CPLMalloc( sizeof(void *) );
	papoLayers[0] = new OGRFGDLayer( pszFilename );
	if ( !papoLayers[0]->isValid() )
		return FALSE;

	pszName = CPLStrdup( pszFilename );

	return TRUE;
}

OGRLayer *OGRFGDDataSource::GetLayer( int iLayer )
{
	if ( iLayer < 0 || iLayer >= nLayers )
		return NULL;
	else
		return papoLayers[iLayer];
}
