
#include "ogr_fgd.h"


OGRFGDDriver::~OGRFGDDriver()
{
}

/************************************************************************/
/*                           GetName()                                  */
/************************************************************************/
const char *OGRFGDDriver::GetName()
{
	return "FGD";
}


/************************************************************************/
/*                           RegisterOGRFGD()                           */
/************************************************************************/
void RegisterOGRFGD()
{
    if (! GDAL_CHECK_VERSION("OGR/FGD driver"))
        return;
    OGRSFDriverRegistrar::GetRegistrar()->RegisterDriver( new OGRFGDDriver );
}



/************************************************************************/
/*                           Open()                                     */
/************************************************************************/
OGRDataSource *OGRFGDDriver::Open( const char *pszFilename, int bUpdate )
{
	OGRFGDDataSource	*poDS = new OGRFGDDataSource();

	if ( !poDS->Open( pszFilename, bUpdate ) )
	{
		delete poDS;
		return NULL;
	}
	else
		return poDS;
}



/************************************************************************/
/*                           TestCapability()                           */
/************************************************************************/
int OGRFGDDriver::TestCapability( const char *pszCap )
{
	if ( EQUAL( pszCap, ODrCCreateDataSource ) )
		return FALSE;
	else if ( EQUAL( pszCap, ODrCDeleteDataSource ) )
		return FALSE;
	else
		return FALSE;
}

